import java.awt.*;
import java.awt.event.*;

/**
 * ButtonControl: a class whose only reason for being is to
 * respond to button events.
 * 
 * @author Stephen Bloch
 * @version Feb. 20, 2000, version 16
 */
public class ButtonControl implements ActionListener
{
	// instance variables
	private Label firstLabel, secondLabel;
	private TextField theTextField;
	private Button thisButton, thatButton, theOtherButton;

	// constructor(s)
	/**
	 * Constructor for objects of class ButtonControl
	 */
	public ButtonControl(Button thisArg, Button thatArg, Button theOtherArg,
				Label firstArg, Label secondArg, TextField tfArg)
	{
		// initialise instance variables
		this.thisButton = thisArg;
		this.thatButton = thatArg;
		this.theOtherButton = theOtherArg;
		this.firstLabel = firstArg;
		this.secondLabel = secondArg;
		this.theTextField = tfArg;
	}

	public void actionPerformed (ActionEvent e) {
		// respond to button press
		// Since this object is the listener for several different buttons,
		// our first job is to figure out which button was pressed.
		if (e.getSource() == thisButton) {
			firstLabel.setText("This!");
			}
		else if (e.getSource() == thatButton) {
			firstLabel.setText("That!");
			}
		else if (e.getSource() == theOtherButton) {
			if (e.getActionCommand().equals("The other Button")) {
				theOtherButton.setLabel ("Use text field");
				firstLabel.setText("The other!");
				}
			else {
				firstLabel.setText(theTextField.getText());
				}
			}
		else {
			firstLabel.setText("This can't happen!");
			}
		}
}
