
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

/**
 * Differences from version 15: the button response has also been moved out
 * of the Applet into another class ButtonControl, which implements ActionListener;
 * indeed, that's its only reason for existing.  This makes the Applet a good deal
 * shorter and simpler.
 *
 * @author Stephen Bloch 
 * @version 4 Dec 2000, version 16
 */
public class MyApplet extends Applet
{

	// Instance variables
	int counter = 1;
	Label firstLabel, secondLabel;
	TextField theTextField;
	Button thisButton, thatButton, theOtherButton;
	MyCanvas theCanvas;
	ButtonControl theControl;

	/**
	 * Called by the browser or applet viewer to inform this Applet that it
	 * has been loaded into the system. It is always called before the first 
	 * time that the start method is called.
	 */
	public void init()
	{
		// provide any initialisation necessary for your Applet

//		ballX = 30;
//		ballY = 60;
		String message = this.getParameter ("message");
		int ballDX = Integer.parseInt (this.getParameter ("dx"));
		int ballDY = Integer.parseInt (this.getParameter ("dy"));
		theCanvas = new MyCanvas (30,60, ballDX, ballDY);

		secondLabel = new Label("                         "); // room for 25 characters
		firstLabel = new Label(message);
		theTextField = new TextField("Your name here");
		thisButton = new Button ("This Button");
		thatButton = new Button ("That Button");
		theOtherButton = new Button ("The other Button");

		theControl = new ButtonControl (thisButton, thatButton,
			theOtherButton, firstLabel, secondLabel, theTextField);

		thisButton.addActionListener (theControl);
		thatButton.addActionListener (theControl);
		theOtherButton.addActionListener (theControl);
		// Note: they don't need to all have the same object as listener.
		// If they do, its actionPerformed() method needs to check which one
		// triggered the event.

		Panel textPanel = new Panel ();
		Panel buttonPanel = new Panel ();

		this.setLayout (new BorderLayout());
		this.add (textPanel,BorderLayout.NORTH);
		this.add (buttonPanel,BorderLayout.SOUTH);
		this.add (theCanvas,BorderLayout.CENTER);
// For some reason I don't understand, the addition of a Canvas in the CENTER
// causes the Applet to no longer receive paint() methods at all; ONLY its
// subcomponents are paint()ed.  As a result, we no longer get the label that
// tells how many paint() methods there have been.
// Moral: in general, you should EITHER use GUI components and layouts, OR
// write a paint() method in your Applet -- not both.

		textPanel.add (firstLabel);
		textPanel.add (secondLabel);
		textPanel.add (theTextField);
		buttonPanel.add (thisButton);
		buttonPanel.add (thatButton);
		buttonPanel.add (theOtherButton);

	}

	/**
	 * This may be the most important method in your applet: Here, the 
	 * drawing of the applet gets done. "paint" gets called everytime the
	 * applet should be drawn on the screen. So put the code here that
	 * shows the applet.
	 *
	 * @param  g   the Graphics object for this applet
	 */
	public void paint(Graphics g)
	{
		secondLabel.setText ("paint() call #" + counter++);
		// note that all the other stuff has moved to the Canvas
	}
// The above method is apparently never called; I don't know why.

	public String[][] getParameterInfo () {
		final String[][] answer =
				{{"message","String","a message to be printed on the screen"},
				 {"dx","integer","how fast the ball should move in the x direction"},
				 {"dy","integer","how fast the ball should move in the y direction"}};
		return answer;
		}


}
