
import java.applet.Applet;
import java.awt.*;

/**
 * Differences from version 6: the labels and TextField have moved from being
 * local variables of init() to being instance variables of the class, so they
 * can be accessed by other methods (although they're not, yet).
 *
 * @author Stephen Bloch 
 * @version 24 Nov 2000, version 7
 */
public class MyApplet extends Applet
{

	// Instance variables
	int ballX, ballY;
	int ballDX = 10;
	int ballDY = 5;
	int counter = 1;
	String message;
	Label firstLabel, secondLabel;
	TextField theTextField;

	/**
	 * Called by the browser or applet viewer to inform this Applet that it
	 * has been loaded into the system. It is always called before the first 
	 * time that the start method is called.
	 */
	public void init()
	{
		// provide any initialisation necessary for your Applet
		ballX = 30;
		ballY = 60;

		message = this.getParameter ("message");
		ballDX = Integer.parseInt (this.getParameter ("dx"));
		ballDY = Integer.parseInt (this.getParameter ("dy"));

		secondLabel = new Label("This is another label");
		firstLabel = new Label("This is a label");
		theTextField = new TextField("Your name here");

		this.add (firstLabel);
		this.add (secondLabel);
		this.add (theTextField);
	}

	/**
	 * This may be the most important method in your applet: Here, the 
	 * drawing of the applet gets done. "paint" gets called everytime the
	 * applet should be drawn on the screen. So put the code here that
	 * shows the applet.
	 *
	 * @param  g   the Graphics object for this applet
	 */
	public void paint(Graphics g)
	{
		// simple text displayed on applet
		g.setColor(Color.white);
		g.fillRect(0, 0, 3000, 3000);
		g.setColor(Color.red);
		g.drawString("paint() call #" + counter++, 30, 20);
		g.drawString (message, 40, 40);
		g.setColor(Color.red);
		g.drawLine(50,50,300,5);
		g.setColor (Color.red);
		g.fillOval (ballX,ballY,80,50);
		ballX += ballDX;
		ballY += ballDY;
		repaint ();
		// NOTE: this is NOT the "approved" way to animate a picture,
		// but it's the easiest to demonstrate on Day 1.
	}

	public String[][] getParameterInfo () {
		final String[][] answer =
				{{"message","String","a message to be printed on the screen"},
				 {"dx","integer","how fast the ball should move in the x direction"},
				 {"dy","integer","how fast the ball should move in the y direction"}};
		return answer;
		}

}
